Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/IUpdateLocation.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/IUpdateLocation.cs	(revision 2517)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/IUpdateLocation.cs	(revision 2517)
@@ -0,0 +1,48 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Runtime.Serialization;
+using System.ServiceModel;
+using System.Text;
+using System.IO;
+
+namespace HeuristicLab.Update.Service {
+  [ServiceContract]
+  public interface IUpdateLocation {
+
+    [OperationContract]
+    IEnumerable<PluginInformation> GetAvailablePlugins();
+
+    [OperationContract]
+    Stream GetPackedPlugin(PluginInformation info);
+  }
+
+
+  [DataContract]
+  public class PluginInformation {
+    private string name;
+    [DataMember]
+    public string Name {
+      get { return name; }
+      set { name = value; }
+    }
+    private Version version;
+    [DataMember]
+    public Version Version {
+      get { return version; }
+      set { version = value; }
+    }
+    private DateTime buildDate;
+    [DataMember]
+    public DateTime BuildDate {
+      get { return buildDate; }
+      set { buildDate = value; }
+    }
+
+    public PluginInformation(string name, Version version, DateTime buildDate) : base() {
+      this.name = name;
+      this.version = version;
+      this.buildDate = buildDate;
+    }
+  }
+}
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/Properties/AssemblyInfo.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/Properties/AssemblyInfo.cs	(revision 2517)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/Properties/AssemblyInfo.cs	(revision 2517)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Update.Service")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab.Update.Service")]
+[assembly: AssemblyCopyright("Copyright ©  2009")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("4cf19b3e-8a57-4288-a226-ca6dedb2cee1")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/UpdateLocation.svc
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/UpdateLocation.svc	(revision 2517)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/UpdateLocation.svc	(revision 2517)
@@ -0,0 +1,1 @@
+﻿<%@ ServiceHost Language="C#" Debug="true" Service="HeuristicLab.Update.Service.UpdateLocation" CodeBehind="UpdateLocation.svc.cs" %>
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/UpdateLocation.svc.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/UpdateLocation.svc.cs	(revision 2517)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/UpdateLocation.svc.cs	(revision 2517)
@@ -0,0 +1,39 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Runtime.Serialization;
+using System.ServiceModel;
+using System.Text;
+using System.IO;
+using HeuristicLab.PluginInfrastructure.Manager;
+using ICSharpCode.SharpZipLib.Zip;
+
+namespace HeuristicLab.Update.Service {
+  public class UpdateLocation : IUpdateLocation {
+
+    #region IUpdateLocation Members
+
+    public IEnumerable<PluginInformation> GetAvailablePlugins() {
+      yield break;
+    }
+
+    public System.IO.Stream GetPackedPlugin(PluginInformation info) {
+      MemoryStream memStream = new MemoryStream();
+      ZipOutputStream stream = new ZipOutputStream(memStream);
+      ZipEntryFactory fac = new ZipEntryFactory();
+      foreach (string fileName in GetMatchingPluginDescription(info.Name, pluginManager.Plugins).Files) {
+        stream.PutNextEntry( (Path.Combine(pluginDir, fileName)));
+      }
+
+      return memStream;
+    }
+
+    private static PluginDescription GetMatchingPluginDescription(string name, IEnumerable<PluginDescription> plugins) {
+      return (from x in plugins
+              where x.Name == name
+              select x).Single();
+    }
+
+    #endregion
+  }
+}
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/Web.config
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/Web.config	(revision 2517)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Update.Service/Web.config	(revision 2517)
@@ -0,0 +1,138 @@
+﻿<?xml version="1.0"?>
+<!--
+    Note: As an alternative to hand editing this file you can use the 
+    web admin tool to configure settings for your application. Use
+    the Website->Asp.Net Configuration option in Visual Studio.
+    A full list of settings and comments can be found in 
+    machine.config.comments usually located in 
+    \Windows\Microsoft.Net\Framework\v2.x\Config 
+-->
+<configuration>
+
+
+    <configSections>
+      <sectionGroup name="system.web.extensions" type="System.Web.Configuration.SystemWebExtensionsSectionGroup, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35">
+        <sectionGroup name="scripting" type="System.Web.Configuration.ScriptingSectionGroup, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35">
+          <section name="scriptResourceHandler" type="System.Web.Configuration.ScriptingScriptResourceHandlerSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication"/>
+          <sectionGroup name="webServices" type="System.Web.Configuration.ScriptingWebServicesSectionGroup, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35">
+            <section name="jsonSerialization" type="System.Web.Configuration.ScriptingJsonSerializationSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="Everywhere" />
+            <section name="profileService" type="System.Web.Configuration.ScriptingProfileServiceSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication" />
+            <section name="authenticationService" type="System.Web.Configuration.ScriptingAuthenticationServiceSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication" />
+            <section name="roleService" type="System.Web.Configuration.ScriptingRoleServiceSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication" />
+          </sectionGroup>
+        </sectionGroup>
+      </sectionGroup>
+    </configSections>  
+
+
+    <appSettings/>
+    <connectionStrings/>
+
+    <system.web>
+        <!--
+            Set compilation debug="true" to insert debugging 
+            symbols into the compiled page. Because this 
+            affects performance, set this value to true only 
+            during development.
+        -->
+        <compilation debug="true">
+
+          <assemblies>
+            <add assembly="System.Core, Version=3.5.0.0, Culture=neutral, PublicKeyToken=B77A5C561934E089"/>
+            <add assembly="System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+          </assemblies>
+
+        </compilation>
+        <!--
+            The <authentication> section enables configuration 
+            of the security authentication mode used by 
+            ASP.NET to identify an incoming user. 
+        -->
+        <authentication mode="Windows" />
+        <!--
+            The <customErrors> section enables configuration 
+            of what to do if/when an unhandled error occurs 
+            during the execution of a request. Specifically, 
+            it enables developers to configure html error pages 
+            to be displayed in place of a error stack trace.
+
+        <customErrors mode="RemoteOnly" defaultRedirect="GenericErrorPage.htm">
+            <error statusCode="403" redirect="NoAccess.htm" />
+            <error statusCode="404" redirect="FileNotFound.htm" />
+        </customErrors>
+        -->
+
+
+      <pages>
+        <controls>
+          <add tagPrefix="asp" namespace="System.Web.UI" assembly="System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+        </controls>
+      </pages>
+
+      <httpHandlers>
+        <remove verb="*" path="*.asmx"/>
+        <add verb="*" path="*.asmx" validate="false" type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+        <add verb="*" path="*_AppService.axd" validate="false" type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+        <add verb="GET,HEAD" path="ScriptResource.axd" type="System.Web.Handlers.ScriptResourceHandler, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" validate="false"/>
+      </httpHandlers>
+      <httpModules>
+        <add name="ScriptModule" type="System.Web.Handlers.ScriptModule, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+      </httpModules>
+
+
+    </system.web>
+
+    <system.codedom>
+      <compilers>
+        <compiler language="c#;cs;csharp" extension=".cs" warningLevel="4"
+                  type="Microsoft.CSharp.CSharpCodeProvider, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+          <providerOption name="CompilerVersion" value="v3.5"/>
+          <providerOption name="WarnAsError" value="false"/>
+        </compiler>
+      </compilers>
+    </system.codedom>
+
+    <!--
+        The system.webServer section is required for running ASP.NET AJAX under Internet
+        Information Services 7.0.  It is not necessary for previous version of IIS.
+    -->
+    <system.webServer>
+      <validation validateIntegratedModeConfiguration="false"/>
+      <modules>
+        <add name="ScriptModule" preCondition="integratedMode" type="System.Web.Handlers.ScriptModule, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+      </modules>
+      <handlers>
+        <remove name="WebServiceHandlerFactory-Integrated"/>
+        <add name="ScriptHandlerFactory" verb="*" path="*.asmx" preCondition="integratedMode"
+             type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+        <add name="ScriptHandlerFactoryAppServices" verb="*" path="*_AppService.axd" preCondition="integratedMode"
+             type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+        <add name="ScriptResource" preCondition="integratedMode" verb="GET,HEAD" path="ScriptResource.axd" type="System.Web.Handlers.ScriptResourceHandler, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" />
+      </handlers>
+    </system.webServer>
+
+
+  <system.serviceModel>
+    <services>
+      <service behaviorConfiguration="HeuristicLab.Update.Service.UpdateLocationBehavior"
+        name="HeuristicLab.Update.Service.UpdateLocation">
+        <endpoint address="" binding="wsHttpBinding" contract="HeuristicLab.Update.Service.IUpdateLocation">
+          <identity>
+            <dns value="localhost" />
+          </identity>
+        </endpoint>
+        <endpoint address="mex" binding="mexHttpBinding" contract="IMetadataExchange" />
+      </service>
+    </services>
+    <behaviors>
+      <serviceBehaviors>
+        <behavior name="HeuristicLab.Update.Service.UpdateLocationBehavior">
+          <!-- To avoid disclosing metadata information, set the value below to false and remove the metadata endpoint above before deployment -->
+          <serviceMetadata httpGetEnabled="true"/>
+          <!-- To receive exception details in faults for debugging purposes, set the value below to true.  Set to false before deployment to avoid disclosing exception information -->
+          <serviceDebug includeExceptionDetailInFaults="true"/>
+        </behavior>
+      </serviceBehaviors>
+    </behaviors>
+  </system.serviceModel>
+</configuration>
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.sln
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.sln	(revision 2516)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.sln	(revision 2517)
@@ -258,9 +258,5 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.PluginInfrastructure.Manager", "HeuristicLab.PluginInfrastructure.Manager\HeuristicLab.PluginInfrastructure.Manager.csproj", "{CA8AAD91-E8E2-41AF-96AD-2BA94BC3EF2D}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Update.Service", "HeuristicLab.Update.Service\HeuristicLab.Update.Service.csproj", "{175263A8-716D-40AC-85A1-E837F6F4736A}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Update.Interfaces", "HeuristicLab.Update.Interfaces\HeuristicLab.Update.Interfaces.csproj", "{F47613C0-06D3-4314-8DAD-F992850A3B23}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Update.Client", "HeuristicLab.Update.Client\HeuristicLab.Update.Client.csproj", "{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}"
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Update.Service", "HeuristicLab.Update.Service\HeuristicLab.Update.Service.csproj", "{39619691-BDCA-44E1-9642-ADA5F85C62A2}"
 EndProject
 Global
@@ -4111,76 +4107,28 @@
 		{CA8AAD91-E8E2-41AF-96AD-2BA94BC3EF2D}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
 		{CA8AAD91-E8E2-41AF-96AD-2BA94BC3EF2D}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.CEDMA Debug|x64.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.CEDMA Debug|x86.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Debug|x86.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Modeling Debug|x64.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Modeling Debug|x86.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Release|Any CPU.Build.0 = Release|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Release|x64.ActiveCfg = Release|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Release|x86.ActiveCfg = Release|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
-		{175263A8-716D-40AC-85A1-E837F6F4736A}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.CEDMA Debug|x64.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.CEDMA Debug|x86.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Debug|x86.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Modeling Debug|x64.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Modeling Debug|x86.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Release|Any CPU.Build.0 = Release|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Release|x64.ActiveCfg = Release|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Release|x86.ActiveCfg = Release|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
-		{F47613C0-06D3-4314-8DAD-F992850A3B23}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.CEDMA Debug|x64.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.CEDMA Debug|x86.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Debug|x86.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Modeling Debug|x64.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Modeling Debug|x86.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Release|Any CPU.Build.0 = Release|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Release|x64.ActiveCfg = Release|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Release|x86.ActiveCfg = Release|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
-		{A8EDF081-459A-4A3D-9F5C-D565A9B01F52}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.CEDMA Debug|x64.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.CEDMA Debug|x86.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Modeling Debug|x64.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Modeling Debug|x86.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Release|Any CPU.Build.0 = Release|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Release|x64.ActiveCfg = Release|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Release|x86.ActiveCfg = Release|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
+		{39619691-BDCA-44E1-9642-ADA5F85C62A2}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab/Program.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab/Program.cs	(revision 2516)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab/Program.cs	(revision 2517)
@@ -29,4 +29,5 @@
 using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.PluginInfrastructure.Advanced;
+using System.Runtime.InteropServices;
 
 namespace HeuristicLab {
@@ -58,23 +59,21 @@
             }
           case "SHOW": {
-              InstallationManager manager = new InstallationManager();
-              foreach (string info in manager.Show(args.Skip(1))) {
-                Console.WriteLine(info);
-              }
+              InstallationManagerConsole managerConsole = new InstallationManagerConsole();
+              managerConsole.Show(args.Skip(1));
               break;
             }
           case "INSTALL": {
-              InstallationManager manager = new InstallationManager();
-              manager.Install(args.Skip(1));
+              InstallationManagerConsole managerConsole = new InstallationManagerConsole();
+              managerConsole.Install(args.Skip(1));
               break;
             }
           case "UPDATE": {
-              InstallationManager manager = new InstallationManager();
-              manager.Update(args.Skip(1));
+              InstallationManagerConsole managerConsole = new InstallationManagerConsole();
+              managerConsole.Update(args.Skip(1));
               break;
             }
           case "REMOVE": {
-              InstallationManager manager = new InstallationManager();
-              manager.Remove(args.Skip(1));
+              InstallationManagerConsole managerConsole = new InstallationManagerConsole();
+              managerConsole.Remove(args.Skip(1));
               break;
             }
